%% bare_conf.tex
%% V1.3
%% 2007/01/11
%% by Michael Shell
%% See:
%% http://www.michaelshell.org/
%% for current contact information.
%%
%% This is a skeleton file demonstrating the use of IEEEtran.cls
%% (requires IEEEtran.cls version 1.7 or later) with an IEEE conference paper.
%%PushPull:Streaming
%% Support sites:
%% http://www.michaelshell.org/tex/ieeetran/
%% http://www.ctan.org/tex-archive/macros/latex/contrib/IEEEtran/
%% and
%% http://www.ieee.org/

%%*************************************************************************
%% Legal Notice:
%% This code is offered as-is without any warranty either expressed or
%% implied; without even the implied warranty of MERCHANTABILITY or
%% FITNESS FOR A PARTICULAR PURPOSE! 
%% User assumes all risk.
%% In no event shall IEEE or any contributor to this code be liable for
%% any damages or losses, including, but not limited to, incidental,
%% consequential, or any other damages, resulting from the use or misuse
%% of any information contained here.
%%
%% All comments are the opinions of their respective authors and are not
%% necessarily endorsed by the IEEE.
%%
%% This work is distributed under the LaTeX Project Public License (LPPL)
%% ( http://www.latex-project.org/ ) version 1.3, and may be freely used,
%% distributed and modified. A copy of the LPPL, version 1.3, is included
%% in the base LaTeX documentation of all distributions of LaTeX released
%% 2003/12/01 or later.
%% Retain all contribution notices and credits.
%% ** Modified files should be clearly indicated as such, including  **
%% ** renaming them and changing author support contact information. **
%%
%% File list of work: IEEEtran.cls, IEEEtran_HOWTO.pdf, bare_adv.tex,
%%                    bare_conf.tex, bare_jrnl.tex, bare_jrnl_compsoc.tex
%%*************************************************************************

% *** Authors should verify (and, if needed, correct) their LaTeX system  ***
% *** with the testflow diagnostic prior to trusting their LaTeX platform ***
% *** with production work. IEEE's font choices can trigger bugs that do  ***
% *** not appear when using other class files.                            ***
% The testflow support page is at:
% http://www.michaelshell.org/tex/testflow/



% Note that the a4paper option is mainly intended so that authors in
% countries using A4 can easily print to A4 and see how their papers will
% look in print - the typesetting of the document will not typically be
% affected with changes in paper size (but the bottom and side margins will).
% Use the testflow package mentioned above to verify correct handling of
% both paper sizes by the user's LaTeX system.
%
% Also note that the "draftcls" or "draftclsnofoot", not "draft", option
% should be used if it is desired that the figures are to be displayed in
% draft mode.
%
\documentclass[10pt,journal,comsoc]{IEEEtran}
%\documentclass[10pt]{IEEEtran}
\usepackage[T1]{fontenc}% optional T1 font encoding
\usepackage{times}
\usepackage{url}
\usepackage{caption} 
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{textcomp}
\usepackage{gensymb}
\usepackage{float}
\usepackage{caption} 
\usepackage{subcaption}
\usepackage{array}
\usepackage{listings}
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}
\usepackage{amsmath}
\interdisplaylinepenalty=2500
\usepackage[cmintegrals]{newtxmath}

%\captionsetup{font=footnotesize,justification=centering,labelsep=period}


% Add the compsoc option for Computer Society conferences.
%
% If IEEEtran.cls has not been installed into the LaTeX system files,
% manually specify the path to it like:
% \documentclass[conference]{../sty/IEEEtran}





% Some very useful LaTeX packages include:
% (uncomment the ones you want to load)


% *** MISC UTILITY PACKAGES ***
%
%\usepackage{ifpdf}
% Heiko Oberdiek's ifpdf.sty is very useful if you need conditional
% compilation based on whether the output is pdf or dvi.
% usage:
% \ifpdf
%   % pdf code
% \else
%   % dvi code
% \fi
% The latest version of ifpdf.sty can be obtained from:
% http://www.ctan.org/tex-archive/macros/latex/contrib/oberdiek/
% Also, note that IEEEtran.cls V1.7 and later provides a builtin
% \ifCLASSINFOpdf conditional that works the same way.
% When switching from latex to pdflatex and vice-versa, the compiler may
% have to be run twice to clear warning/error messages.






% *** CITATION PACKAGES ***
%
%\usepackage{cite}
% cite.sty was written by Donald Arseneau
% V1.6 and later of IEEEtran pre-defines the format of the cite.sty package
% \cite{} output to follow that of IEEE. Loading the cite package will
% result in citation numbers being automatically sorted and properly
% "compressed/ranged". e.g., [1], [9], [2], [7], [5], [6] without using
% cite.sty will become [1], [2], [5]--[7], [9] using cite.sty. cite.sty's
% \cite will automatically add leading space, if needed. Use cite.sty's
% noadjust option (cite.sty V3.8 and later) if you want to turn this off.
% cite.sty is already installed on most LaTeX systems. Be sure and use
% version 4.0 (2003-05-27) and later if using hyperref.sty. cite.sty does
% not currently provide for hyperlinked citations.
% The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/cite/
% The documentation is contained in the cite.sty file itself.






% *** GRAPHICS RELATED PACKAGES ***
%
\ifCLASSINFOpdf
  \usepackage[pdftex]{graphicx}
  % declare the path(s) where your graphic files are
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  \DeclareGraphicsExtensions{.pdf,.jpeg,.png}
\else
  % or other class option (dvipsone, dvipdf, if not using dvips). graphicx
  % will default to the driver specified in the system graphics.cfg if no
  % driver is specified.
  % \usepackage[dvips]{graphicx}
  % declare the path(s) where your graphic files are
  % \graphicspath{{../eps/}}
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  % \DeclareGraphicsExtensions{.eps}
\fi
% graphicx was written by David Carlisle and Sebastian Rahtz. It is
% required if you want graphics, photos, etc. graphicx.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at: 
% http://www.ctan.org/tex-archive/macros/latex/required/graphics/
% Another good source of documentation is "Using Imported Graphics in
% LaTeX2e" by Keith Reckdahl which can be found as epslatex.ps or
% epslatex.pdf at: http://www.ctan.org/tex-archive/info/
%
% latex, and pdflatex in dvi mode, support graphics in encapsulated
% postscript (.eps) format. pdflatex in pdf mode supports graphics
% in .pdf, .jpeg, .png and .mps (metapost) formats. Users should ensure
% that all non-photo figures use a vector format (.eps, .pdf, .mps) and
% not a bitmapped formats (.jpeg, .png). IEEE frowns on bitmapped formats
% which can result in "jaggedy"/blurry rendering of lines and letters as
% well as large increases in file sizes.
%
% You can find documentation about the pdfTeX application at:
% http://www.tug.org/applications/pdftex





% *** MATH PACKAGES ***
%
%\usepackage[cmex10]{amsmath}
% A popular package from the American Mathematical Society that provides
% many useful and powerful commands for dealing with mathematics. If using
% it, be sure to load this package with the cmex10 option to ensure that
% only type 1 fonts will utilized at all point sizes. Without this option,
% it is possible that some math symbols, particularly those within
% footnotes, will be rendered in bitmap form which will result in a
% document that can not be IEEE Xplore compliant!
%
% Also, note that the amsmath package sets \interdisplaylinepenalty to 10000
% thus preventing page breaks from occurring within multiline equations. Use:
%\interdisplaylinepenalty=2500
% after loading amsmath to restore such page breaks as IEEEtran.cls normally
% does. amsmath.sty is already installed on most LaTeX systems. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/required/amslatex/math/





% *** SPECIALIZED LIST PACKAGES ***
%
%\usepackage{algorithmic}
% algorithmic.sty was written by Peter Williams and Rogerio Brito.
% This package provides an algorithmic environment fo describing algorithms.
% You can use the algorithmic environment in-text or within a figure
% environment to provide for a floating algorithm. Do NOT use the algorithm
% floating environment provided by algorithm.sty (by the same authors) or
% algorithm2e.sty (by Christophe Fiorio) as IEEE does not use dedicated
% algorithm float types and packages that provide these will not provide
% correct IEEE style captions. The latest version and documentation of
% algorithmic.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithms/
% There is also a support site at:
% http://algorithms.berlios.de/index.html
% Also of interest may be the (relatively newer and more customizable)
% algorithmicx.sty package by Szasz Janos:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithmicx/




% *** ALIGNMENT PACKAGES ***
%
%\usepackage{array}
% Frank Mittelbach's and David Carlisle's array.sty patches and improves
% the standard LaTeX2e array and tabular environments to provide better
% appearance and additional user controls. As the default LaTeX2e table
% generation code is lacking to the point of almost being broken with
% respect to the quality of the end results, all users are strongly
% advised to use an enhanced (at the very least that provided by array.sty)
% set of table tools. array.sty is already installed on most systems. The
% latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/required/tools/


%\usepackage{mdwmath}
%\usepackage{mdwtab}
% Also highly recommended is Mark Wooding's extremely powerful MDW tools,
% especially mdwmath.sty and mdwtab.sty which are used to format equations
% and tables, respectively. The MDWtools set is already installed on most
% LaTeX systems. The lastest version and documentation is available at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/mdwtools/


% IEEEtran contains the IEEEeqnarray family of commands that can be used to
% generate multiline equations as well as matrices, tables, etc., of high
% quality.


%\usepackage{eqparbox}
% Also of notable interest is Scott Pakin's eqparbox package for creating
% (automatically sized) equal width boxes - aka "natural width parboxes".
% Available at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/eqparbox/





%\usepackage[tight,footnotesize]{subfigure}
% subfigure.sty was written by Steven Douglas Coc
% *** SUBFIGURE PACKAGES ***hran. This package makes it
% easy to put subfigures in your figures. e.g., "Figure 1a and 1b". For IEEE
% work, it is a good idea to load it with the tight package option to reduce
% the amount of white space around the subfigures. subfigure.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at:
% http://www.ctan.org/tex-archive/obsolete/macros/latex/contrib/subfigure/
% subfigure.sty has been superceeded by subfig.sty.



%\usepackage[caption=false]{caption}
%\usepackage[font=footnotesize]{subfig}
% subfig.sty, also written by Steven Douglas Cochran, is the modern
% replacement for subfigure.sty. However, subfig.sty requires and
% automatically loads Axel Sommerfeldt's caption.sty which will override
% IEEEtran.cls handling of captions and this will result in nonIEEE style
% figure/table captions. To prevent this problem, be sure and preload
% caption.sty with its "caption=false" package option. This is will preserve
% IEEEtran.cls handing of captions. Version 1.3 (2005/06/28) and later 
% (recommended due to many improvements over 1.2) of subfig.sty supports
% the caption=false option directly:
%\usepackage[caption=false,font=footnotesize]{subfig}
%
% The latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/subfig/
% The latest version and documentation of caption.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/caption/




% *** FLOAT PACKAGES ***
%
%\usepackage{fixltx2e}
% fixltx2e, the successor to the earlier fix2col.sty, was written by
% Frank Mittelbach and David Carlisle. This package corrects a few problems
% in the LaTeX2e kernel, the most notable of which is that in current
% LaTeX2e releases, the ordering of single and double column floats is not
% guaranteed to be preserved. Thus, an unpatched LaTeX2e can allow a
% single column figure to be placed prior to an earlier double column
% figure. The latest version and documentation can be found at:
% http://www.ctan.org/tex-archive/macros/latex/base/



%\usepackage{stfloats}
% stfloats.sty was written by Sigitas Tolusis. This package gives LaTeX2e
% the ability to do double column floats at the bottom of the page as well
% as the top. (e.g., "\begin{figure*}[!b]" is not normally possible in
% LaTeX2e). It also provides a command:
%\fnbelowfloat
% to enable the placement of footnotes below bottom floats (the standard
% LaTeX2e kernel puts them above bottom floats). This is an invasive package
% which rewrites many portions of the LaTeX2e float routines. It may not work
% with other packages that modify the LaTeX2e float routines. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/sttools/
% Documentation is contained in the stfloats.sty comments as well as in the
% presfull.pdf file. Do not use the stfloats baselinefloat ability as IEEE
% does not allow \baselineskip to stretch. Authors submitting work to the
% IEEE should note that IEEE rarely uses double column equations and
% that authors should try to avoid such use. Do not be tempted to use the
% cuted.sty or midfloat.sty packages (also by Sigitas Tolusis) as IEEE does
% not format its papers in such ways.



% *** PDF, URL AND HYPERLINK PACKAGES ***
%
%\usepackage{url}
% url.sty was written by Donald Arseneau. It provides better support for
% handling and breaking URLs. url.sty is already installed on most LaTeX
% systems. The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/misc/
% Read the url.sty source comments for usage information. Basically,
% \url{my_url_here}.





% *** Do not adjust lengths that control margins, column widths, etc. ***
% *** Do not use packages that alter fonts (such as pslatex).         ***
% There should be no need to do such things with IEEEtran.cls V1.6 and later.
% (Unless specifically asked to do so by the journal or conference you plan
% to submit to, of course. )

%\raggedbottom
%My Custom style to suppress space in text paragraph


% correct bad hyphenation here
\hyphenation{op-tical net-works semi-conduc-tor}

%\parskip 6pt plus 2pt minus 1pt
%\parskip 3pt plus 2pt minus 1pt

%\pagestyle{empty}


\begin{document}
%\pagenumbering{gobble}
%
% paper title
% can use linebreaks \\ within to get better formatting as desired
\title{\textbf{\Large Towards an Interactive Video Delivery Network (VDN) based on Router-centric TCP
\\[-1.5ex]}}

% author names and affiliations
% use a multiple column layout for up to three different
% affiliations
\author{MD Iftakharul Islam,~\IEEEmembership{Student Member,~IEEE,} and Javed I Khan
\thanks{Manuscript received April 15, 2018;}}


% conference papers do not typically use \thanks and this command
% is locked out in conference mode. If really needed, such as for
% the acknowledgment of grants, issue a \IEEEoverridecommandlockouts
% after \documentclass

% for over three affiliations, or if they all won't fit within the width
% of the page, use this alternative format:
% 
%\author{\IEEEauthorblockN{Michael Shell\IEEEauthorrefmark{1},
%Homer Simpson\IEEEauthorrefmark{2},
%James Kirk\IEEEauthorrefmark{3}, 
%Montgomery Scott\IEEEauthorrefmark{3} and
%Eldon Tyrell\IEEEauthorrefmark{4}}
%\IEEEauthorblockA{\IEEEauthorrefmark{1}School of Electrical and Computer Engineering\\
%Georgia Institute of Technology,
%Atlanta, Georgia 30332--0250\\ Email: see http://www.michaelshell.org/contact.html}
%\IEEEauthorblockA{\IEEEauthorrefmark{2}Twentieth Century Fox, Springfield, USA\\
%Email: homer@thesimpsons.com}
%\IEEEauthorblockA{\IEEEauthorrefmark{3}Starfleet Academy, San Francisco, California 96678-2391\\
%Telephone: (800) 555--1212, Fax: (888) 555--1212}
%\IEEEauthorblockA{\IEEEauthorrefmark{4}Tyrell Inc., 123 Replicant Street, Los Angeles, California 90210--4321}}


% The paper headers
\markboth{IEEE Transactions on Network and Service Management}%
{Shell \MakeLowercase{\textit{et al.}}: Bare Demo of IEEEtran.cls for IEEE Communications Society Journals}
% The only time the second header will appear is for the odd numbered pages
% after the title page when using the twoside option.
% 
% *** Note that you probably will NOT want to include the author's ***
% *** name in the headers of peer review papers.                   ***
% You can use \ifCLASSOPTIONpeerreview for conditional compilation here if
% you desire.

% use for special paper notices
%\IEEEspecialpapernotice{(Invited Paper)}

%copyright
%\IEEEoverridecommandlockouts
%\IEEEpubid{\hspace{-\columnwidth}978-1-5090-6501-1/17/\$31.00 ©2017 IEEE}


% make the title area
\maketitle


\begin{abstract}
%\boldmath
Interactive video is projected to make up a major portion of total Internet traffic in the future. However current Internet architecture is not suitable for interactive video streaming. Interactive video streaming over the Internet compete with loss-sensitive traffic. Such loss-sensitive traffic cause \textit{bufferbloat problem} which increases delay to interactive video streaming applications. Interactive video streaming over the Internet are also expected to behave in a TCP-friendly manner. This is why the video streaming application cannot achieve higher throughput than loss-sensitive traffic which results in poor QoE. This paper presents an interactive video delivery network (VDN) to solve these problems. Here interactive video streaming applications compete among themselves. Interactive VDN is designed based on a router-centric TCP. Here sending rate is regulated based on the feedback from the router. We have implemented NC-TCP in Linux kernel. We also have developed NC-TCP dataplane in Linux router. Finally we have developed a TCP-based adaptive video streaming application. We have evaluated NC-TCP in several Mininet testbeds. Our theoretical analysis and experimental results show promising results toward the realization of an interactive VDN. 

\end{abstract}
% IEEEtran.cls defaults to using nonbold math in the Abstract.
% This preserves the distinction between vectors and scalars. However,
% if the conference you are submitting to favors bold math in the abstract,
% then you can use LaTeX's standard command \boldmath at the very start
% of the abstract to achieve this. Many IEEE journals/conferences frown on
% math in the abstract anyway.

% no keywords

\begin{IEEEkeywords}
Interactive Video Streaming; Router-centric TCP; Linux XDP Router Implementation%
\end{IEEEkeywords}



% For peer review papers, you can put extra information on the cover
% page as needed:
% \ifCLASSOPTIONpeerreview
% \begin{center} \bfseries EDICS Category: 3-BBND \end{center}
% \fi
%
% For peerreview papers, this IEEEtran command inserts a page break and
% creates the second title. It will be ignored for other modes.
\IEEEpeerreviewmaketitle



\section{Introduction}
\subsection{Background and Motivation}
% no \IEEEPARstart
Interactive video streaming over the Internet are expected to behave in a TCP-friendly manner. For example, Skype uses a TCP-friendly congestion control algorithm for video conferencing \cite{zhang2012profiling}. However interactive video streaming applications are adversely affected by competing TCP flows. Loss-based congestion control of TCP fills up the router buffer (\textit{bufferbloat problem}) which increases delay. Moreover, interactive video streaming traditionally employs delay based congestion control algorithms. The delay-based congestion algorithms have several critical issues. They lose throughput to loss-based TCP \cite{grieco2004performance} when competing with them. They also perform poorly in fairness \cite{de2013experimental, carlucci2016congestion} when competing among themselves which results in poor QoE in video streaming applications. This paper presents an interactive video delivery network (VDN) to solve these problems. Here interactive video traffic competes among themselves. This obviates the need for TCP-friendliness and enables us to design a congestion control algorithm optimized for interactive video streaming. Here the video streaming applications use a router-centric congestion control rather than delay based approach. Our experimental results show that the router-centric congestion control in VDN results in significant improvement over delay-based counterpart. This is the first proposal towards a VDN to the best of our knowledge. SDN/NFV based 5G network will allow us to create end-to-end network slice \cite{ordonez2017network} on top of existing network infrastructure. This will enable us to deploy VDN in real life. 

\subsection{Summery of the Proposed VDN}
Interactive VDN is designed based on programmable routers. Here the routers provide explicit feedbacks to the senders. The feedback becomes the sending rate at the senders. Routers calculate a feedback such a way that the queuing delay is minimized (near zero queuing delay) and  the link-utilization is maximized and flows get a fair-share of the link capacity. Explicit feedback based TCP however is not new. XCP \cite{katabi2002internet} is the first attempt in this direction where explicit rate is assigned by the router based on persistent queuing delay and spare capacity of the bottleneck link. XCP is found to perform significantly better than host-centric TCP in reducing latency and maximizing throughput \cite{katabi2002internet, tamim}. But XCP makes no assumption about the traffic characteristic. Later we  developed NC-TCP \cite{tamim} where we assumed that the network only carries video traffic and the video streaming applications only compete among themselves. This paper is an enhancement of our previous work on NC-TCP \cite{tamim}. The previous work on NC-TCP did not include an utilization controller. The previous work also did not include dataplane implementation. Here we have implemented NC-TCP router in Linux kernel. Linux kernel on a general purpose computer can act as a router \cite{xdp}. Recently Linux XDP framework \cite{xdp} have been implemented where router dataplane can be implemented in Linux kernel. We have developed NC-TCP router based on Linux XDP. Our experimental results show that NC-TCP router can forward packets at line-rate with 40Gb/s NICs.

\subsection{Related works}
Video streaming applications in the Internet traditionally use one-way delay based congestion mechanism over RTP/RTCP. This includes Cisco NADA \cite{zhu2013nada}, Google Congestion Control (GCC) \cite{carlucci2016analysis} and so on. NADA uses one-way delay whereas GCC uses one-way delay gradient to regulate the sending rate. TCP Igino \cite{shewmaker2016tcp} also use one-way delay gradient as GCC. Although delay-gradient based congestion control algorithms have been widely used for interactive video streaming, it has shown that they suffer from fairness issue \cite{de2013experimental, carlucci2016congestion}. It is important to mention that if flows cannot share link-throughput fairly, it results in poor video quality for the flows. Software defined networks (SDN) however can solve this problem by providing an explicit feedback from the network. XCP \cite{katabi2002internet} and RCP \cite{dukkipati2007rate} are primary attempts in this direction where an explicit rate is assigned by the routers along the path. XCP tries to minimize delay while maximizing link utilization. RCP on the other hand is designed to minimize flow completion time. RCP results in high queuing delay \cite{dukkipati2007rate}. This is why it is not suitable for interactive video streaming. Although XCP results in small queuing delay, it makes no assumption about the traffic characteristic. In this paper however, we design a network-centric TCP (NC-TCP) for interactive VDN. Here we utilize the traffic characteristics to optimize throughput allocation. To the best of our knowledge, this is the first proposal towards an interactive VDN. Moreover here we have implemented NC-TCP router based on Linux XDP. To the best of our knowledge, this is the first research work where Linux XDP has been used to implement a router dataplane.  

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{workflow}
	\caption{Work flow of NC-TCP}\label{workflow}
\end{figure}

\begin{figure}[!t]
	\centering
	\includegraphics[width=3cm]{im-option}
	\caption{NC-TCP option header}\label{im-option}
\end{figure}

\subsection{Basic NC-TCP workflow}
The workflow of NC-TCP is shown in Figure \ref{workflow}. A sender specifies the desired throughput at SYN and DATA packets. The feedback throughput would be set by the routers. The routers allocate a feedback throughput based on the link capacity, number of active flows and queue occupancy. Receivers copy the feedback throughput to the acknowledgement packets. In this way, the feedback throughput would be returned to the sender. This is how the routers send explicit feedback to the senders. The feedback throughput would be used as the sending rate in the sender. Traditional TCP uses window based congestion control. Window-based congestion control however produces bursty traffic. Video streaming traditionally uses rate-based congestion control \cite{carlucci2016congestion}. NC-TCP has been designed as a rate-based congestion control. It uses \textit{TCP-pacing} \cite{aggarwal2000understanding} to regulate the sending rate. We have implemented NC-TCP as a new TCP option (TCP extension). The NC-TCP option header contains of two fields: \textit{desired throughput} and \textit{feedback throughput}. Figure \ref{im-option} shows the NC-TCP option along option type and option length. TCP option is the intended mechanism by which TCP can be extended. An empirical experiment has shown that it is possible to extend TCP by implementing a new option even though the packets go through plethora of middle-boxes \cite{honda2011still} . 

A video streaming flow may have more than one bottleneck links along the path. A bottleneck router would set a feedback rate to a packet if the feedback rate is smaller than the feedback rate already set in the packet (i.e. the feedback calculated by a previous router). In this way, a more congested downstream router can further reduce this feedback by overwriting it. This ensures that the outgoing rate of a sender is adjusted to the most congested link on the path. Again if feedback rate of a router is larger than the feedback rate already set in the packet, then the router does not set the feedback rate. This is because it indicates that a more congested router already set the feedback rate.

In this paper, we assume that flows in a VDN does not change its path very frequently. That is, a flow will almost always takes the same path. If a flow changes its path very frequently, feedback throughput would become irrelevant. This is why, the routers in a VDN are configured in a way that a flow does not changes its path very frequently.   

The remaining of the paper proceeds as follows. We first describe the rationale for using TCP in interactive VDN in Section II. In Section III, we design the congestion control algorithm. In Section IV, we design an encoder rate control algorithm. Section V discusses the difference between NC-TCP and XCP. Section VI and VII discuss NC-TCP host and router implementation respectively. Section VIII discusses the experimental setup and the Section IX shows the experimental results. Finally Section X concludes the paper.
			
\section{{Why TCP?}}
Interactive video streaming traditionally uses application layer rate control algorithm over UDP \cite{carlucci2016congestion}. But this approach has some disadvantages. It forces the application developers to reimplement the common functionalities. Different implementations of the congestion control algorithms interact poorly with each other, and the stability of the network is compromised. UDP is also not NAT and firewall friendly which are highly desirable attributes in today's Internet. TCP solves those problems,  however it has some disadvantages in the context of interactive video streaming. The ordered delivery of TCP delays some segment delivery if a prior segment is missing (\textit{head-of-line blocking } problem). Retransmission is also not often desirable in interactive video streaming. However it has shown that this problem can be avoided by modifying TCP implementation. Recently TCP Hollywood \cite{mcquistin2016tcp} has been designed as an unordered and time-line oriented TCP. It avoids the \textit{head-of-line blocking } problem by supporting unordered delivery. It also attaches a time-line to data. The data would be ignored after the time-line has been expired. This is how it avoids retransmission. Packet-loss can be further avoided by caching packets on the router. As NICs (network interface controllers) evolved from kbps to Gbps and memory chips from KB to GB, packet loss has become less of an issue. 


\section{Congestion Control}
To compute the feedback, a NC-TCP router uses a \textit{delay controller}, \textit{fairness controller} and \textit{utilization controller}. Delay controller uses queue size to calculate the aggregate feedback throughput. Fairness controller divides the aggregate feedback throughput equally among the flows. Finally we design an \textit{utilization controller} that adapts the feedback throughput in order to avoid link under-utilization.  

\subsection{Delay Controller}
The delay controller is designed based on Proportional Integral (PI) controller. It calculates the aggregate feedback throughput based queue length and link capacity. In PI controller, the aggregate feedback throughput can described by the following equation:

\begin{equation}\label{eq1} \sum r_i(t) = \alpha[c(t) - q(t)]\end{equation}

where the $\sum r_i(t)$ is the aggregate feedback throughput, $c(t)$ is the bottleneck link capacity, $q(t)$ is the queue length in bytes and $\alpha$ is the coefficient. We need to determine the value of $\alpha$ for which the system stabilizes. Later we show that the system stabilizes when $\alpha > 0$. The value of $\alpha$ is used to regulate the queuing delay and throughput. There is a trade-off between throughput and queuing delay. Later we show that $\alpha=1$ makes the queuing delay approaches to zero and at the same time maximizing the feedback throughput.

It is noteworthy that Active Queue Management (AQM) techniques used PI controller in the past. For instance, PI Enhanced (PIE) \cite{pan2013pie} controller has been designed where routers set ECN bit in the packet to give a hint about the queuing delay. In contrast, NC-TCP routers set a feedback throughput. The feedback throughput from the router will be used as the sending rate of  the sender.

\subsection{Fairness Controller}
The objective of the fairness controller is to divide the capacity equally among the flows. We can rewrite the equation (\ref{eq1}) as $r_i(t) = \frac{\alpha[c(t) - s(t)]}{N(t)}$ where $r_i(t)$ is the feedback throughput for flow $i$ and $N(t)$ is the number of active flows in the router at time $t$. Note that it is trivial to implement weighted-fairness in fairness controller. As the routers explicitly allocates feedback throughput among the flows, it is trivial to implement different fairness strategy which are non-trivial to implement in a host-centric TCP.


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{tandemqueue}
	\caption{Feedback throughput from each router is shown where actual link throughput is $X$. Here link utilization is less than 100\%}\label{tandemqueue}
\end{figure}

\subsection{Utilization Controller}
The utilization controller is responsible for avoiding link under-utilization. Links in a network can be underutilized if there are multiple bottleneck routers (tandem queue) in the network. Figure \ref{tandemqueue} shows such a network. Here the figure shows a topology where the capacity of each link is $X$. The feedback throughput from each router is also shown in the figure. For instance, router $r1$ is setting feedback throughput $X/2$ to flow $f1$ and $f2$. Again router $r2$ is setting feedback throughput $X/3$ to flow $f1$, $f3$ and $f4$ and $x/2$ to flow $f2$. This is why $s1$ and $s2$ will receive feedback throughput $X/3$ and $X/2$ respectively. This is because a source will receive smallest feedback-throughput set by the routers along the path. As a result, the link between $r1$ and $r2$ would be receiving packets at $5X/6$ rate while its capacity is $X$. That is, the link is 83.3\% utilized. Utilization controller solves this problem by artificially inflating the link capacity.

Utilization controller is based on spare capacity. Spare capacity of a router  is calculated as

\begin{equation}\label{eq2} s(t) = c(t) - y(t) - q(t-1)\end{equation}
where $s(t)$ is the spare capacity at time $t$, $c$ is the link capacity, $y(t)$ is the amount of incoming traffic in past one second and $q(t-1)$ represents the queue size at the beginning of past second. $s(t)$ can be negative or positive. $s(t) \leq 0 $ indicates that the link has been fully utilized. On the other hand, positive $s(t)$ indicates that the link has not been fully utilized. Utilization controller does not calculate feedback throughput directly. It rather regulates $c(t)$ which is used by the delay and fairness controller. It regulates $c(t)$ based on $s(t)$ and $q(t)$. 

Algorithm 1 shows the utilization controller. The utilization controller is a state-machine that consists of three states: INIT, INFLATED and UTILIZED. Initially it stays at INIT. $c(t)$ contains actual link capacity at that time. If it detects a positive $s(t)$ (link underutilization), it increases $c(t)$ by $s(t)$ and moves to INFLATED. As a result, these additional spare capacity would be distributed among the flows. Inflated state however does not ensure that the link will be fully utilized. If the controller is at INFLATED state and it finds $s(t) > 0$, it indicates that adding $s(t-1)$ at previous state (INIT) did not achieve full utilization. This however allows us to estimate how much inflation is needed in order to achieve full utilization. In previous state (INIT), the controller added $s(t-1)$ in order to increase utilization by the same amount. But it resulted spare capacity $s(t)$. That is, inflating by $s(t-1)$ increased utilization by $s(t-1) - s(t)$. This is why, in order to increase utilization by $s(t-1)$, we needed to increase $c(t)$ by $\frac{s(t-1)^2}{s(t-1) - s(t)} \Big(i.e. \frac{s(t-1)}{\frac{s(t-1) - s(t)}{s(t-1)}}\Big)$. Note that this is calculated with respect to the controller in INIT state. This is why $c(t)$ is inflated as $c(t) = c(t) + \frac{s(t-1)^2}{s(t-1) - s(t)} - s(t-1)$. The controller also moves to UTILIZED state at that time.

Finally UTILIZED state indicates that the controller has inflated $c(t)$ in order to utilize the link completely. UTILIZED is a steady state. It does not change $c(t)$. However when $q(t)$ or $s(t)$ reaches their predefined maximum value, it moves back to INIT.   

\begin{algorithm}
	\caption{Utilization Controller}\label{euclid}
	\begin{algorithmic}[1]
		\Procedure{Initialization}{}
		\State $state \gets \textit{INIT}$
		\State $c(t) \gets \textit{actual link capacity}$
		\EndProcedure		

		\Procedure{changeState}{$s(t), s(t-1), q(t)$}
		\If {$state = \textit{INIT}$}
			\If {$s(t) > 0$}
				\State $c(t) = c(t) + s(t)$
				\State $state \gets \textit{INFLATED}$
			\EndIf
		\ElsIf {$state = \textit{INFLATED}$}
			\If {$s(t) > 0$ and $s(t-1) > s(t)$}
				\State $c(t) = c(t) + \frac{s(t-1)^2}{s(t-1) - s(t)} - s(t-1)$
			\EndIf
			\State $state \gets \textit{UTILIZED}$
		\ElsIf {$state = \textit{UTILIZED}$}
		\State/*q\_max and s\_max are predefined threshold
		\State of $q(t)$ and $s(t)$ respectively*/
		\If {$q(t) > q\_max$ or $s(t) > s\_max$}
			\State \textbf{call} INITIALIZATION()			
		\EndIf				
		\EndIf		
		\EndProcedure
	\end{algorithmic}
\end{algorithm}

\begin{figure}[!t]
	\centering
	\includegraphics[width=7cm]{underutilized}
	\caption{Underutilized link $b$ is desirable}\label{underutilized}
\end{figure}

Note that utilization controller simply increases the aggregate feedback throughput by the spare capacity. If this increase does not achieve full utilization, it increases the aggregate feedback rate by $\frac{s(t-1)^2}{s(t-1) - s(t)} - s(t-1)$. However cannot guarantee 100\% link utilization. That is because if the feedback can be overwritten by other routers along the path. In that case, utilization controller have no effect. However there is nothing wrong with that. For instance, in Figure \ref{underutilized}, it is desirable to have the link $b$ underutilized.


\subsection{Stability Analysis}
This section shows that NC-TCP always converges to an equilibrium point. First we will prove that the delay and fairness controller are stable. Then we will prove that the system remains stable after utilization controller is applied. 

The feedback rate set by the router is sent back to the sender via acknowledgment. This is why there is a feedback delay in NC-TCP. Let us assume that the feedback delay is $t_f$. As the feedback rate becomes the sending rate after $t_f$,the sending rate at time $t$ can be written as
\begin{equation}\label{eq5}x_i(t) = \frac{\alpha [C - q(t - t_f)]}{N}\end{equation} where $C$ is the link capacity. Here we assume that the link capacity is constant. For the sake of tractability, like all previous works, we assume that all the flows have a common, finite, and positive round-trip delay \cite{katabi2002internet, dukkipati2007rate}. However, in the experimental evaluation, we evaluate NC-TCP with flows with diverse RTTs as recommended in IETF TCP evaluation suite \cite{hayes2013common}. We also assume that the number of flows  are constant for a session. The queuing-delay gradient can be represented as \begin{equation}\label{eq3}
\dot{q(t)} = \sum x_i(t) - C
\end{equation}
As the flows adapt their sending rate $x_i(t)$ at the same rate, $\sum x_i(t) = N x_i(t)$ for all $i$. From equation (\ref{eq5}) and (\ref{eq3}) we get,  
\begin{equation}\label{eq4}
\dot{q(t)} = N x_i(t) - C  \implies \dot{q(t)} = -\alpha q(t - t_f) + C(\alpha-1)
\end{equation}

This is an autonomous differential equation which describes an autonomous system. According to the stability theorem of autonomous differential equation, the system is stable if $\ddot{q(t^*)} < 0$ where $q(t^*)$ represents the queuing delay at the equilibrium point. Here $\ddot{q(t^*)} = -\alpha$. This is why the system is stable if $\alpha > 0$. If the system is perturbed by burst of flows, the $q(t)$ increases. In that case, the queue will be drained at $-\alpha q(t - t_f) + C(\alpha-1)$ rate and eventually reaches the equilibrium point. 

At the equilibrium point, $\dot{q(t) = 0}$. Thus from the equation (\ref{eq4}), we get \begin{equation}\label{eq6}
q(t - t_f) = \frac{C(\alpha-1)}{\alpha}
\end{equation}
$\frac{C(\alpha-1)}{\alpha}$ is the queuing delay at the equilibrium point. The value of $\alpha$ controls the queuing delay and feedback throughput. Here we want the queuing delay to be be zero while maximizing the throughput. That is why we initialize $\alpha = 1$.


\textbf{THEOREM 1.} \textit{The system remains stable under utilization controller}

Utilization controller is applied when there are multiple bottleneck links and one or more of them are underutilized. The router along with the bottleneck link increases the feedback  throughput to increase the link utilization. We need to prove that such increase in feedback throughput has no negative impact on stability. Let us assume that the feedback throughput of a router $r_u$ is $f_u$ after applying the utilization controller. Here $f_u$ is an inflated feedback based on the utilization controller. Note that all the flows of the router get the same inflated feedback. Now there can be two scenarios to each flow: 

\textbf{Case 1.} There exist no other router along the path that sets feedback throughput less than $f_u$. In that case, sender of the flow will receive the feedback. But router $r_u$ will reach to UTILIZED state because INFLATED is a transitory state. On the other hand, UTILIZED is a steady state. Here link capacity is not changed unless $q(t)$ or $s(t)$ drifts from their acceptable limit. In that case, utilization controller will move back to INIT state which is stable (because it delay and fairness controller are stable) 

\textbf{Case 2.} There exist another router $r_i$ along the path that sets feedback less than $f_u$. This is why, feedback of $r_u$ would be overwritten by the feedback of $r_i$.  If $r_i$ is fully utilized (not using utilization controller), then its feedback throughput allocation is stable (as delay and fairness controller are stable). On the other hand, if $r_i$ is also underutilized, then it is also setting an inflated feedback. In this way, the sender of the flow will receive an inflated feedback  as in case 1. But note that this inflation is due to link underutilization and hence necessary. But as in case 1, the router $r_i$ will reach to UTILIZED state. As UTILIZED is an equilibrium state as it does not change $c$ unless $q(t)$ or $s(t)$  reaches their acceptable limit. This is how $r_i$ will reach to an equilibrium point.      

Note that utilization controller is designed to be stable. It does not change $c(t)$ if the link is fully utilized. If the link is underutilized, it increases feedback throughput and moves to INFLATED. But inflated is a transitory state. It always moves to UTILIZED state irrespective of $s(t)$. Finally UTILIZED is a steady state. It does not reacts to changes in link utilization or queue size unless they drift substantially from the user defined acceptable value. This is why utilization controller is also stable. 

\section{Encoder Rate Control}
One of the main challenges of interactive video streaming is that the encoding rate of video cannot be changed quickly in order to avoid congestion. The video encoder reacts to encoding rate changes over discrete intervals which is usually more than 500 milliseconds. The actual encoder output rate also fluctuates randomly around the input target rate. The actual output rate of a video depends on the content of the video. This section shows how to set the target encoding rate based on the feedback rate.

The encoding rate in an adaptive video streaming is set based on the throughput of the network. Contrary to that, NC-TCP based application sets the target rate based on the feedback rate of the network. NC-TCP uses a rate-based congestion control mechanism to regulate the sending rate. It uses \textit{TCP-pacing} to regulate the sending rate. The sending rate is set to the feedback throughput. This is why NC-TCP does not send more data than what the network would be able to handle. As a result, although it results in a very small queuing delay, packets may wait in the TCP's sending buffer (congestion window) to be scheduled to sent out. This increases the RTT. This is why RTT produced by the NC-TCP is not exactly same as the propagation delay. Rather $RTT/RTT_{min}$ indicates how much encoder has overshot with respect to the network throughput. Here $RTT_{min}$ is the minimum RTT which is considered as the \textit{propagation delay}. We set the encoder target rate as 
\begin{displaymath}
R_t(t) = \frac{r_i(t)}{\frac{RTT}{RTT_{min}}}
\end{displaymath}
where $r_i(t)$ is the feedback throughput received from the network. Note that $\frac{RTT}{RTT_{min}} \geq 1$. This is why the target encoding rate is less than the feedback throughput. This is how NC-TCP based appliactions set the target encoding rate based on the network-feedback and past history of overshooting.  
 
\section{Difference between NC-TCP and XCP}
NC-TCP host is designed as a rate-based congestion mechanism as opposed to XCP. It uses TCP-pacing to regulate the sending rate. That is why, it does not send bursty traffic and it does not send more data than the network is able to deliver. NC-TCP also uses instantaneous queue backlog to calculate the feedback rate whereas XCP calculates the feedback rate based on the standing queue: minimum queue length over a control interval. This is why NC-TCP reacts to congestion quicker than XCP. Our experimental results show that NC-TCP performs better in containing small queue size compared to XCP in an video Internet. Our experimental results also show that both NC-TCP and XCP preforms significantly better than delay-based congestion control, TCP Inigo in an interactive VDN.


\section{NC-TCP Implementation}
We have implemented NC-TCP and XCP in Linux kernel\footnote{https://github.com/tamimcse/Linux}. We also have made it available as a separate patch\footnote{https://github.com/tamimcse/Linux/blob/master/mypatches/nc-tcp.patch1}. We also have found that TCP Inigo Linux kernel implementation in the Internet \footnote{https://github.com/systemslab/tcp\_inigo}. Our software architecture for both NC-TCP and XCP includes two parts: NC-TCP host and NC-TCP router.

NC-TCP end point is implemented by adding a new option to Linux TCP stack. In contrast to the traditional TCP, NC-TCP uses \textit{TCP-pacing} \cite{aggarwal2000understanding} to regulate the sending rate. Here the sending rate is set to the feedback rate received from the network. The congestion window is also set $\frac{r_i(t) * RTT}{MSS}$ where $MSS$ represents the \textit{maximum segment size}. Linux TCP stack does not have a native \textit{TCP-pacing} implementation. TCP-pacing has been implemented using \textit{fq} (fair queue) Qdisc (queuing discipline). Qdisc is the traffic control mechanism in the Linux kernel. XCP on the other hand uses window based congestion control. XCP sender calculates the congestion window based on the feedback received from the XCP router.

NC-TCP router has been implemented in the Linux router as a new Qdisc kernel module. We have used Linux router by enabling the \textit{ip\_forward} option in Linux. The Qdisc kernel module inspects the NC-TCP option and sets a feedback rate based on the delay and fairness controller. XCP router is also implemented in the same manner where the rate in calculated based on the controller described in \cite{katabi2002internet}. 

\section{Data plane implementation}
This section describes how NC-TCP protocol is implemented in a programmable router. Programmable routers can be divided into two categories: Reconfigurable switching chip (offers limited programmability) and Software router (fully programmable). Reconfigurable switching chips are developed based on TCAM. Example of reconfigurable switching chip include Barefoot tofino switch \cite{bosshart2013forwarding} and Cavium Xplaint switch \cite{xplaint}. XCP and RCP protocols have been implemented in reconfigurable switching chip in the past \cite{sharma17evaluating}. On the other hand, software routers can be developed based on CPU, GPU or FPGA \cite{yang2014guarantee, asai2015poptrie, li2013gamt}. In this paper we have implemented NC-TCP protocol in a CPU based software router.

\begin {table}[H]
\caption {CPU based software routers which are being used by ISPs} \label{npu} 
\begin{center}
	\begin{tabular}{ | m{2.6cm}| m{2.9cm} | m{1.5cm}|} 
		\hline Router Series & CPU & Per-CPU Forwarding Throughput (Gbps) \\ 
		\hline Cisco ASR \cite{qfp, wheeler2013new} & Cisco QFP & 100  \\		
		\hline Cisco CRS \cite{wheeler2013new} & Cisco nPower X1 & 400 \\	
		\hline Ericsson SSR \cite{wheeler2013new} & Ericsson SNP 4000 & 200 \\				 								 		
		\hline 6Wind vRouter \cite{6wind} & Intel Xeon E5-2667 v4 & 370 \\ 				 		  			
		\hline Cisco VPP Router \cite{xeon} & Intel Xeon Platinum 8168 & - \\	 				 		
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\subsection{CPU based software routers}
TCAM based reconfigurable switching chips have many limitations. They have issues with power consumption and heat. They are also very limited in capacity. This is why although TCAM based routers are widely used in data centers, carrier routers very often use CPUs for packet processing. Table \ref{npu} shows a list of CPU based software routers which are currently being used by ISPs. In this paper, we have implemented NC-TCP protocol in an Intel X86 CPU based router. There are several dataplane frameworks for X86 routers. These include Linux XDP \cite{hoiland2018express}, DPDK \cite{gallenmuller2015comparison}, Netmap \cite{rizzo2012netmap} and so on. In this paper, we have implemented NC-TCP protocol in Linux XDP. 

\subsection{NC-TCP Router implementation:}
Linux kernel has a fast data-path called eXpress Data Path (XDP) \cite{hoiland2018express} to implement packet forwarding. This allows Linux to work as a software router. We have implemented NC-TCP protocol in XDP. Algorithm 2 shows the implementation of the \textit{NC\_TCP\_ROUTER()}. The function processes each packet in a run-to-completion fashion. Here Line 2 checks if the size of the packet is smaller than $55$; if yes, then it is not a valid packet and should be ignored. Line 4 parses the IP header from the packet. Note that parsing IP header is simply adding $14$ (the length of ethernet header) to the start of the packet. This simplifies packet processing to a great extent. As layer-2/3/4 headers have fixed formats, we can parse the headers by pointer jumping. Line 5 calls \textit{fib\_lookup()} to find the destination NIC for the packet. A routing table is also known as forwarding information base (FIB). \textit{fib\_lookup()} here looks up the routing table in order to find the destination NIC. Routing table lookup is a key functionality of a router. Forwarding rate of a router primarily depends on the routing table lookup algorithm. Linux kernel uses LC-trie \cite{nilsson1999ip} for routing table lookup. Recently however SAIL \cite{yang2014guarantee} and Poptrie \cite{asai2015poptrie} have been proposed which improved the routing table lookup performance significantly. We have implemented SAIL in Linux kernel \footnote{https://github.com/tamimcse/Linux/blob/master/mypatches/sail.patch1}. In this paper, \textit{fib\_lookup()} uses SAIL for routing table lookup. The details of routing table lookup however is out of the scope of this paper. Line 6 calculates the feedback throughput based on the delay and fairness controller. Note that the utilization controller simply updates the link capacity. This is why utilization controller is not directly used here. Line 7 extracts the feedback rate from the TCP option header of the packet. Note that here it is done by adding $50$ to the start of the packet and reading the value of the pointer. This is because the IP header is 20 bytes long, ethernet header is 14 bytes long and the offset inside TCP option header is 16 bytes. Line 8 and 9 shows that the feedback rate is written to the packet if the feedback rate is smaller than the current feedback rate. Finally the packet is transmitted through the destination NIC. 

It is noteworthy that a NC-TCP router does not need to store per-flow state. It however uses active flow-count to calculate the feedback throughput. However accurate flow counting is a computationally expensive task. It requires a router to inspect source and destination IP address and port number of each packet to see if the packet belongs to a new flow. This is why high speed routers use probabilistic counting for active flow-count \cite{estan2003bitmap}. In this paper, we use \textit{virtual bitmap} \cite{estan2003bitmap} to count the active flow-count. The detail of the procedure however is out of the scope of this paper.
 
\begin{algorithm}
	\caption{NC-TCP router}\label{euclid}
	\textbf{Input}: Pointer to the incoming packet $data$ \\
	\textbf{Input}: Pointer to the end of the packet $data\_end$ \\
	\begin{algorithmic}[1]		
		
		\Procedure{{nc\_tcp\_router}}{$data, data\_end$}
		
		\If {$data\_end - data < 84$}
		\State {return}
		\EndIf

		\State $ip\_hdr \gets data + 14$	
				
		\State $nic \gets fib\_lookup(ip\_hdr.dest\_ip)$		
		\If {$new\_flow(nic, ip\_hdr.src\_ip, ip\_hdr.dst\_ip)$}
		\State $dst\_nic.flow\_count++$	
		\EndIf
		\State $feedback\_rate \gets \frac{nic.capacity - 
			nic.queue\_size}{nic.flow\_count}$
		\State $current\_rate \gets *(data + 50)$
						 				
		\If {$feedback\_rate < current\_rate$}
		\State $*(data + 50) \gets feedback\_rate$	
		\EndIf
		\State{Notify DMA that the packet is ready to be transmitted}		
		\EndProcedure

		\Procedure{{new\_flow}}{$nic, src\_ip, dst\_ip$}
		
		\If {$data\_end - data < 85$}
		\State {return}
		\EndIf
		
		\State $ip\_hdr \gets data + 14$	
		
		\EndProcedure
		
	\end{algorithmic}
\end{algorithm} 


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{topology}
	\caption{Topology}\label{topology}
\end{figure}



\begin{figure*}[!t]
	\vspace{-5\baselineskip}
	\begin{subfigure}[t]{\textwidth}
		\includegraphics[width=9cm]{h1-throughput}
		\includegraphics[width=9cm]{backlog}
	\end{subfigure}
	\begin{subfigure}[t]{\textwidth}
		\vspace{-3\baselineskip}
		\includegraphics[width=9cm]{h1-rtt}
		\includegraphics[width=9cm]{fairness}
	\end{subfigure}%
	\vspace{-3\baselineskip}	
	\caption{Comparison among NC-TCP, XCP and TCP Inigo in an interactive VDN}\label{im-cubuc}
\end{figure*}

\section{Experimental Setup}
We have created a topology as Figure \ref{topology} using Mininet \cite{lantz2010network}. We have used \textit{NetEm} Qdisc to set the delay and \textit{htb} (hierarchical token bucket) Qqisc to set the throughputs on the network interfaces\footnote{http://lartc.org/}. We verified the throughput and latency of our setup using \textit{ping} and \textit{iperf}. We have run our experiment on a laptop running Ubuntu 16.04 with our modified Linux kernel 4.9.0. The laptop has a core i7 processor with four cores and 16GB memory.

We also developed a GStreamer\footnote{https://gstreamer.freedesktop.org/} based application\footnote{https://github.com/tamimcse/gst-streamer} in C to stream video from the sources. The source nodes act as a TCP server and the sink nodes act as a TCP client. Once the connection has been established, the server streams video to the client. In this experiment, we used a clip from Big Buck Bunny\footnote{http://bbb3d.renderfarming.net/download.html}.  The source application produces \textit{512X340} video at 30 fps.  This video is encoded into H.264 format. Here we used adaptive bitrate streaming where the bitrate of the video is adapted based on the network throughput. We used one-pass constant bitrate (CBR) encoder to produce the desired bitrate. Such one-pass encoder is traditionally used for real-time streaming. The GStreamer source updates the encoding rate in every 500 milliseconds. It uses \textit{getsockopt} system call to get feedback throughput from the TCP stack. It updates the encoding rate based on the feedback. On the receiving side, each node has a GStreamer sink application that plays the video as soon as a new NAL (network abstraction layer) unit is received.     


\section{Evaluation}
This section compares the performance of NC-TCP with other delay based TCP. Loss-based TCP such as TCP CUBIC \cite{ha2008cubic} results in substantial delay in the router which is not acceptable for interactive traffic. Recently Google proposed congestion based congestion control, TCP BBR \cite{45646} which adjusts the sending rate by probing the network. But it also results in substantial queuing delay in our experimental test-bed which makes it unsuitable for interactive video streaming. We found TCP CDG \cite{hayes2011revisiting} and TCP Inigo \cite{shewmaker2016tcp} to cause very small queuing delay which makes them suitable for interactive video streaming. Moreover we found that TCP Inigo outperforms TCP CDG in achieving higher throughput and lower latency. This is why, in this section we compared the performance of NC-TCP with that of TCP Inigo. This section also compared NC-TCP with XCP \cite{katabi2002internet}. XCP and RCP \cite{dukkipati2007rate} are explicit rate control mechanism which are promising alternative to TCP. RCP is designed to minimize the flow completion time but it results in higher queuing delay \cite{dukkipati2007rate}. This is why RCP is not suitable for interactive video streaming. XCP on the other hand results in very small queuing delay. This is why we also compared NC-TCP to that of XCP. This section compared the performance of one-way flows in order to avoid the reverse path affect. 


\begin{figure*}[!t]

	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{flows-inigo}
		\vspace{-3\baselineskip}
		\caption{Three TCP Inigo flows 15 seconds apart}\label{flows-cdg}
	\end{subfigure}%
	~ 
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{flows-im}
		\vspace{-3\baselineskip}
		\caption{Three NC-TCP flows 15 seconds apart}\label{flows-im}
	\end{subfigure}%	 
	\caption{NC-TCP and TCP Inigo self-fairness comparison}\label{fairness}
\end{figure*}

The primary evaluation criteria in this section are the queuing delay on the bottleneck router and the throughput fairness. As NC-TCP, XCP and TCP Inigo fully utilize the bottleneck link, higher fairness indicates that all the flows get higher throughput while lower fairness indicates that some flows get higher throughput while other flows are not receiving higher throughput from the bottleneck link. 

\textbf{Single bottleneck link}: We have conducted our experiment on the topology described in Figure \ref{topology}. In the experiment, we have started three flows simultaneously and let it run for 80 seconds. We have run the experiment for NC-TCP, XCP and TCP Inigo separately. We have shown the throughput, queuing delay, round-trip time and Jain's fairness index in Figure \ref{im-cubuc}. We have modified the \textit{tcp\_probe} kernel module to record throughput and RTT on the sender. Here \textit{tcp\_probe} takes sample as soon as the congestion window changes. The network-controller we developed also records the queue backlog  using Linux \textit{proc} file system.  


\begin{figure*}[!t]
	\vspace{-3\baselineskip}
	\begin{subfigure}[!t]{\textwidth}
		\includegraphics[width=9cm]{rtt/backlog}
		\includegraphics[width=9cm]{rtt/fairness}		
	\end{subfigure}
	\vspace{-2\baselineskip}	
	\caption{Evaluating RTT fairness for three flows with different RTTs in interactive VDN}\label{rtt-fairness}
\end{figure*}



Figure \ref{im-cubuc} shows that both NC-TCP and XCP produces smooth throughput. Such smooth throughput of is very suitable for adaptive video streaming. On the other hand, the throughput of TCP Inigo fluctuates very rapidly compared to NC-TCP and XCP. 

Figure \ref{im-cubuc} has also shown the queuing delay of the bottleneck router. The queuing delay has been calculated using $\frac{q(t)}{B} $ where $B$ is the bottleneck throughput. The figure shows that NC-TCP outperforms XCP and TCP Inigo in queuing delay. TCP Inigo regulates the sending rate based on the delay-gradient observed on the receiver. It has no real network information. It rather tries to estimate the extent of congestion based on the implicit information, the delay observed on the receiver. NC-TCP on the other hand regulates the sending rate based on the actual congestion information. This is why NC-TCP performs significantly better than TCP Inigo. The figure also shows that XCP produces spikes in queuing delay. This is because it uses standing queue in rate calculation. Standing queue is the minimum queue backlog during a control interval. XCP also uses window-based congestion control which causes bursty traffic in the bottleneck router. NC-TCP on the other hand uses instantaneous queue backlog in rate calculation. This is why it reacts sooner to congestion than XCP. NC-TCP also use \textit{TCP-pacing} to regulate the sending rate. This is why, it does not send bursty traffic to network. 






Figure \ref{im-cubuc} also compared the smoothed RTT (SRTT) experienced by the protocols. It shows that NC-TCP outperforms TCP Inigo and XCP in reducing SRTT. Note that, average RTT in our experimental test-bed is 140 milliseconds. The round-trip time produced by NC-TCP is also close to 140 milliseconds. It is also noteworthy that although queuing delay in NC-TCP is close to zero, the RTT is not equal to the propagation delay. This is because NC-TCP segments may wait in the sender buffer before being scheduled by the \textit{TCP-pacing} Qdisc.  


Finally Figure \ref{im-cubuc} has compared the Jain's fairness index for the protocols. The Jain's fairness index has been calculated using the formula $\frac{{(\sum_{i=1}^{n} x_i)}^2}{n \sum_{i=1}^{n} {x_i}^2}$ where $x_i$ is the throughput of flow $i$ and $n$ is the total number of flows. Higher fairness index indicates that the protocol is better in fairness. The figure shows that both NC-TCP and XCP outperforms TCP Inigo in fairness. It is noteworthy that although XCP exhibits occasional downward spikes in fairness index, it performs very fairly most of the time. Both NC-TCP and XCP divides the bottleneck throughput equally among the flows. This results in very high fairness index. On the contrary, TCP Inigo results in very fluctuating queuing delay which cause the congestion window to fluctuate even more. As a result, TCP Inigo performs poorly in fairness compared to XCP and NC-TCP. Note that low fairness results in lower throughput to some flows which results in lower QoE for interactive video streaming. 





\textbf{Self-fairness}: Here we have examined the self fairness of NC-TCP and TCP Inigo. We have run the experiment again where each flow is 15 seconds apart. Figure \ref{fairness} shows three flows competing for 1Mbps bottleneck link. Figure \ref{flows-cdg} shows that without the present of other flows, TCP Inigo can utilize the available throughput. But it performs poorly when it starts competing with other flows. It changes the congestion window rapidly based on the queuing delay caused by other flows. This is why throughput also fluctuates rapidly. Contrary to that, NC-TCP divides the available throughput equally among the flows. This is why NC-TCP flows get fair throughput from the bottleneck link. Figure \ref{flows-im} shows that NC-TCP also able to utilize the available throughput in the absence of other flows. It also shows that when three NC-TCP shares a bottleneck link, they get nearly fair amount of throughput from the bottleneck link. The throughput also does not fluctuates as much as TCP Inigo which results in better QoE for adaptive video streaming. 


\textbf{RTT-fairness:} The throughput allocation of NC-TCP does not depend on the RTTs of the flows. To evaluate the RTT-fairness of NC-TCP, we have modified the topology in Figure \ref{topology} such that the three different flows have different RTTs:  80ms, 100ms and 120ms. Figure \ref{rtt-fairness} shows the queuing delay and fairness index for the topology. It shows that NC-TCP is fair to flows with different RTTs. NC-TCP is also able to contain the queuing delay in the presence of different RTT flows  (as in Figure \ref{rtt-fairness}). This is why even though the feedback-delays are different for each flow, they receive smooth feedback throughput. On the other hand, XCP and TCP Inigo exhibit spikes in queuing delay. This is why they also exhibit variability in fairness index. 


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{parkinglot}
	\caption{Parking lot topology with multiple bottleneck links}\label{parkinglot}
\end{figure}

\begin{figure*}[!t]
	\vspace{-3\baselineskip}
	\begin{subfigure}[!t]{\textwidth}
		\includegraphics[width=9cm]{parkinglot/backlog}
		\includegraphics[width=9cm]{parkinglot/fairness}		
	\end{subfigure}
	\vspace{-2\baselineskip}	
	\caption{Comparison among NC-TCP, XCP and TCP Inigo in an interactive VDN with multiple bottleneck links}\label{parkinglotres}
\end{figure*}

\textbf{Multiple bottleneck links:} Figure \ref{parkinglot} shows a topology with multiple bottleneck links. Here node $S1$, $S2$, $S3$ and $S4$ act as video sources and $D1$, $D2$, $D3$ and $D4$ act as video sinks. Here each router is a bottleneck router. The link capacity and propagation delays are shown in the figure. We also have introduced 3ms propagation delay variance on the link. We conducted the same experiment as before on this topology. Here four flows are started simultaneously on the source nodes. We let the experiment run for 80 seconds. Figure \ref{parkinglotres} compared performance of NC-TCP to that of TCP Inigo and XCP. The figures shows that both NC-TCP and XCP is very effective in containing queuing delay whereas Inigo results in very high queuing delay in the presence of multiple bottlenecks. NC-TCP also outperforms XCP and Inigo in fairness index. 


\textbf{Differential fairness}: Interactive VDN needs to support heterogeneous endpoints such as smart phones, laptops, TV and VR headset at the same time. The videos used in different endpoints often differ in encodings, resolutions and frame rates. This is why different endpoints may need different throughputs. Network-centric congestion control has a major advantage in this regard. As a router is aware of the throughput requirement of each flow passing through it, it can apply differential fairness in throughput allocation. NC-TCP option (Figure \ref{im-option}) has \textit{desired throughput} field which would be used by the senders to specify their throughput requirements. Bottleneck router can apply weighted fairness based on the \textit{desired throughput} in allocating throughput to each flow.

\begin {table}[H]
\caption {Number of visual interruptions} \label{visual} 
\begin{center}
	\begin{tabular}{ | m{5em} | m{3cm}| m{3cm} | } 
		\hline
		& Single bottleneck & Multiple bottleneck\\ 
		\hline
		TCP Inigo & 2 & 20 \\ 
		\hline
		XCP & 0 & 0 \\ 
		\hline
		NC-TCP & 0 & 0 \\		
		\hline
	\end{tabular}
\end{center}
\end {table}


\textbf{Visual Interruption}: Visual interruption is the situation where video player on a receiver enters into a buffering mode. Such interruption degrades the QoE significantly. Table \ref{visual} shows the number of visual interruptions experienced for different topologies. It shows that both NC-TCP and XCP performs significantly well compared to TCP Inigo. 


\begin{figure}[!t]
	\centering
	\includegraphics[width=7cm]{linerate}
	\caption{Evaluating forwarding performance of Linux XDP}\label{linerate}
\end{figure}

\subsection{{Processing cost of NC-TCP Dataplane}}
This subsection evaluates the processing cost of NC-TCP dataplane. Here we show that NC-TCP dataplane can forward packets at line-rate with a 40 Gb/s NIC. A 40 Gbps NIC produces 3.4 millions packets per second ($\frac{40 \times 10^9}{8 \times 1500}$). Here we assume that packet size is 1500Byte. This is a reasonable assumption because in a video delivery network, most of the packets would be large packets. As a NIC receives 3.4 million packets per second, the CPU has 300ns to process each packet. Algorithm 2 shows the processing NC-TCP router dataplane. Here we evaluate the computing cost of Algorithm 2 in order to find the per-packet processing time. 

We have created a topology as in Figure \ref{linerate} in Mininet. Here \textit{iperf client} generates traffic to the \textit{iperf server} through the router. Here the \textit{iperf client} establishes 10  concurrent connections to the \textit{iperf server} and pushes 1500KB packets. Packets are forwarded using the Algorithm 2. The experiment has been conducted on a laptop with 4 2Ghz core-i7 processor. Here hyper-threading of the processor is disabled in order avoid cache thrashing. x64 processors have TSC\footnote{https://en.wikipedia.org/wiki/Time\_Stamp\_Counter} registers  that keep track of CPU cycles. They also have two special instructions RDTSC and RDTSCP that allow us to read those registers \cite{guide2011intel}. Here we evaluate the processing cost of NC-TCP dataplane by counting the CPU cycles. We have found that the processing cost of each packet is $78\sim140$ cycles. The processing cost primarily varies due to the variability of Routing table lookup time. We have used SAIL \cite{yang2014guarantee} to implement routing table lookup. SAIL itself consumes $23\sim84$ cycles in our experiment. A 2 Ghz processor takes $70ns$ to execute $140$ cycles. This is considerably smaller than 300ns budget for a 40Gb/s NIC. This shows us that NC-TCP router can forward packets at linerate. 


\section{Conclusions}
This paper presents an interactive video delivery network (VDN). Here the interactive video streaming applications only compete among themselves.  This solves many critical issues of interactive video streaming over the Internet. Recent advances in SDN/NFV based network slicing will enable us to deploy such VDN in real life. The VDN is designed based on a network-centric TCP. Here the sending-rate is determined by the routers along the path. We have shown that NC-TCP in a VDN is stable. NC-TCP results in very small queuing delay. NC-TCP also performs very well in fairness which results in high throughput in video streaming applications. We have implemented NC-TCP in the Linux kernel. We have evaluated NC-TCP in several Mininet testbeds. Our experimental results show that VDN will dramatically improve video conferencing over the Internet. Finally we have implemented NC-TCP router in Linux XDP. Our performance analysis shows that NC-TCP dataplane can achieve line-rate with 40Gb/s NICs.

Another important outcome of this paper is that it shows although latency based congestion control algorithms have been widely used in many real-world interactive video streaming applications such as Google Hangout and Cisco telepresence, they perform very poorly compared to NC-TCP and XCP. Our results show that both NC-TCP and XCP outperform TCP Inigo which is a one-way delay gradient based congestion control algorithm similar to the one used in Google Hangout.
 
 


%\appendices
%\section{Proof of the First Zonklar Equation}
%Appendix one text goes here.

% you can choose not to have a title for an appendix
% if you want by leaving the argument blank
%\section{}
%Appendix two text goes here.


% use section* for acknowledgment
\ifCLASSOPTIONcompsoc
% The Computer Society usually uses the plural form
\section*{Acknowledgments}
\else
% regular IEEE prefers the singular form
\section*{Acknowledgment}
\fi


The authors would like to thank the anonymous reviewers for their valuable comments and suggestions to improve the quality of the paper.

% Can use something like this to put references on a page
% by themselves when using endfloat and the captionsoff option.
\ifCLASSOPTIONcaptionsoff
\newpage
\fi

% trigger a \newpage just before the given reference
% number - used to balance the columns on the last page
% adjust value as needed - may need to be readjusted if
% the document is modified later
%\IEEEtriggeratref{8}
% The "triggered" command can be changed if desired:
%\IEEEtriggercmd{\enlargethispage{-5in}}

% references section

% can use a bibliography generated by BibTeX as a .bbl file
% BibTeX documentation can be easily obtained at:
% http://www.ctan.org/tex-archive/biblio/bibtex/contrib/doc/
% The IEEEtran BibTeX style support page is at:
% http://www.michaelshell.org/tex/ieeetran/bibtex/
%\bibliographystyle{IEEEtran}
% argument is your BibTeX string definitions and bibliography database(s)
%\bibliography{IEEEabrv,../bib/paper}
%
% <OR> manually copy in the resultant .bbl file
% set second argument of \begin to the number of references
% (used to reserve space for the reference number labels box)
%
% As suggested below, edit bibtemplate_samples.bib to reflect
% your bibliography. See bibtemplate.text for referencing.
%

\bibliographystyle{IEEEtran}
\bibliography{bibtemplate_samples}


\begin{IEEEbiography}[{\includegraphics[width=1in,height=1in,clip,keepaspectratio]{tamim.jpg}}]%
{MD Iftakharul Islam}
is a PhD candidate of Computer Science department at Kent State University, Ohio, USA. He had his Bachelor degree in Computer Science and Engineering from Bangladesh University of Engineering and Technology (BUET).
\end{IEEEbiography}

% if you will not have a photo at all:
\begin{IEEEbiography}[{\includegraphics[width=1in,height=1.25in,clip,keepaspectratio]{javedkhan.jpeg}}]%
{Javed I Khan}
is a Professor and Chair of Computer Science department at Kent State University, Ohio, USA. He also leads Multimedia Networking lab. He had his PhD degree from University of Hawaii at Manoa and Bachelor degree in Electrical Engineering from Bangladesh University of Engineering and Technology (BUET).
\end{IEEEbiography}


% that's all folks
\end{document}
